xine-lib: xine-lib-1.2.13/src/input/input_gnome_vfs.c File Reference

xine-lib 1.2.13-20230125hg15249

Data Structures | Macros | Functions | Variables
input_gnome_vfs.c File Reference
`#include <xine/xine_internal.h>`
`#include <xine/xineutils.h>`
`#include <xine/input_plugin.h>`
`#include "net_buf_ctrl.h"`
`#include <libgnomevfs/gnome-vfs.h>`

## Data Structures
struct | gnomevfs_input_t

## Macros
#define | D(__VA_ARGS__)
#define | SSH_BUFFER_SIZE 256 * 1024

## Functions
static off_t | gnomevfs_plugin_get_current_pos (input_plugin_t *this_gen)
static uint32_t | gnomevfs_plugin_get_capabilities (input_plugin_t *this_gen)
static off_t | gnomevfs_plugin_read (input_plugin_t *this_gen, void *buf_gen, off_t len)
static buf_element_t * | gnomevfs_plugin_read_block (input_plugin_t *this_gen, fifo_buffer_t *fifo, off_t todo)
static off_t | gnomevfs_plugin_seek (input_plugin_t *this_gen, off_t offset, int origin)
static off_t | gnomevfs_plugin_get_length (input_plugin_t *this_gen)
static uint32_t | gnomevfs_plugin_get_blocksize (input_plugin_t *this_gen)
static const char * | gnomevfs_plugin_get_mrl (input_plugin_t *this_gen)
static int | gnomevfs_plugin_get_optional_data (input_plugin_t *this_gen, void *data, int data_type)
static void | gnomevfs_plugin_dispose (input_plugin_t *this_gen)
static int | gnomevfs_plugin_open (input_plugin_t *this_gen)
static input_plugin_t * | gnomevfs_klass_get_instance (input_class_t *klass_gen, xine_stream_t *stream, const char *mrl)
static void * | init_input_class (xine_t *xine, const void *data)

## Variables
static const char | ignore_scheme [][8] = { "cdda:", "file:", "ftp:", "ftpes:", "http:", "https:", "test:", "hls:"}
static const input_info_t | input_info_gnomevfs
const plugin_info_t xine_plugin_info[] | EXPORTED

## Macro Definition Documentation

## ◆ D

#define D | ( |  | __VA_ARGS__ | ) |

Referenced by gnomevfs_klass_get_instance(), gnomevfs_plugin_get_current_pos(), gnomevfs_plugin_get_length(), gnomevfs_plugin_get_optional_data(), gnomevfs_plugin_open(), gnomevfs_plugin_read(), and gnomevfs_plugin_seek().

## ◆ SSH_BUFFER_SIZE

#define SSH_BUFFER_SIZE 256 * 1024

Referenced by gnomevfs_plugin_read().

## Function Documentation

## ◆ gnomevfs_klass_get_instance()

static input_plugin_t * gnomevfs_klass_get_instance | ( | input_class_t * | klass_gen,
|  | xine_stream_t * | stream,
|  | const char * | mrl )
| static

References D, gnomevfs_plugin_dispose(), gnomevfs_plugin_get_blocksize(), gnomevfs_plugin_get_capabilities(), gnomevfs_plugin_get_current_pos(), gnomevfs_plugin_get_length(), gnomevfs_plugin_get_mrl(), gnomevfs_plugin_get_optional_data(), gnomevfs_plugin_open(), gnomevfs_plugin_read(), gnomevfs_plugin_read_block(), gnomevfs_plugin_seek(), ignore_scheme, nbc_init, and NULL.

Referenced by init_input_class().

## ◆ gnomevfs_plugin_dispose()

static void gnomevfs_plugin_dispose | ( | input_plugin_t * | this_gen | ) |
| static

References _x_freep(), nbc_close, and NULL.

Referenced by gnomevfs_klass_get_instance().

## ◆ gnomevfs_plugin_get_blocksize()

static uint32_t gnomevfs_plugin_get_blocksize | ( | input_plugin_t * | this_gen | ) |
| static

Referenced by gnomevfs_klass_get_instance().

## ◆ gnomevfs_plugin_get_capabilities()

static uint32_t gnomevfs_plugin_get_capabilities | ( | input_plugin_t * | this_gen | ) |
| static

References INPUT_CAP_SEEKABLE, and INPUT_CAP_SPULANG.

Referenced by gnomevfs_klass_get_instance().

## ◆ gnomevfs_plugin_get_current_pos()

static off_t gnomevfs_plugin_get_current_pos | ( | input_plugin_t * | this_gen | ) |
| static

References D, and NULL.

Referenced by gnomevfs_klass_get_instance(), and gnomevfs_plugin_seek().

## ◆ gnomevfs_plugin_get_length()

static off_t gnomevfs_plugin_get_length | ( | input_plugin_t * | this_gen | ) |
| static

References D, and NULL.

Referenced by gnomevfs_klass_get_instance(), and gnomevfs_plugin_open().

## ◆ gnomevfs_plugin_get_mrl()

static const char * gnomevfs_plugin_get_mrl | ( | input_plugin_t * | this_gen | ) |
| static

Referenced by gnomevfs_klass_get_instance().

## ◆ gnomevfs_plugin_get_optional_data()

static int gnomevfs_plugin_get_optional_data | ( | input_plugin_t * | this_gen,
|  | void * | data,
|  | int | data_type )
| static

References D, and INPUT_OPTIONAL_UNSUPPORTED.

Referenced by gnomevfs_klass_get_instance().

## ◆ gnomevfs_plugin_open()

static int gnomevfs_plugin_open | ( | input_plugin_t * | this_gen | ) |
| static

References _, _x_message(), D, gnomevfs_plugin_get_length(), NULL, xine_log(), XINE_LOG_MSG, XINE_MSG_FILE_EMPTY, XINE_MSG_FILE_NOT_FOUND, XINE_MSG_NO_ERROR, XINE_MSG_PERMISSION_ERROR, and XINE_MSG_UNKNOWN_HOST.

Referenced by gnomevfs_klass_get_instance().

## ◆ gnomevfs_plugin_read()

static off_t gnomevfs_plugin_read | ( | input_plugin_t * | this_gen,
|  | void * | buf_gen,
|  | off_t | len )
| static

References D, MIN, and SSH_BUFFER_SIZE.

Referenced by gnomevfs_klass_get_instance(), and gnomevfs_plugin_read_block().

## ◆ gnomevfs_plugin_read_block()

static buf_element_t * gnomevfs_plugin_read_block | ( | input_plugin_t * | this_gen,
|  | fifo_buffer_t * | fifo,
|  | off_t | todo )
| static

References BUF_DEMUX_BLOCK, fifo_buffer_s::buffer_pool_alloc, buf_element_s::content, buf_element_s::free_buffer, gnomevfs_plugin_read(), buf_element_s::max_size, buf_element_s::mem, NULL, buf_element_s::size, and buf_element_s::type.

Referenced by gnomevfs_klass_get_instance().

## ◆ gnomevfs_plugin_seek()

static off_t gnomevfs_plugin_seek | ( | input_plugin_t * | this_gen,
|  | off_t | offset,
|  | int | origin )
| static

References D, and gnomevfs_plugin_get_current_pos().

Referenced by gnomevfs_klass_get_instance().

## ◆ init_input_class()

static void * init_input_class | ( | xine_t * | xine,
|  | const void * | data )
| static

References input_plugin_s::dispose, input_class_s::get_instance, gnomevfs_klass_get_instance(), N_, NULL, XINE_VERBOSITY_DEBUG, and xprintf.

## Variable Documentation

## ◆ EXPORTED

const plugin_info_t xine_plugin_info [] EXPORTED

Initial value:
= {
{ PLUGIN_INPUT | PLUGIN_NO_UNLOAD, 18, "gnomevfs", XINE_VERSION_CODE,
&input_info_gnomevfs, init_input_class },
{ PLUGIN_NONE, 0, NULL, 0, NULL, NULL }
}
input_info_gnomevfs
static const input_info_t input_info_gnomevfs
Definition input_gnome_vfs.c:377
init_input_class
static void * init_input_class(xine_t *xine, const void *data)
Definition input_gnome_vfs.c:347
XINE_VERSION_CODE
#define XINE_VERSION_CODE
Definition xine_internal.h:57
NULL
NULL
Definition xine_plugin.c:78
PLUGIN_NO_UNLOAD
#define PLUGIN_NO_UNLOAD
Definition xine_plugin.h:51
PLUGIN_NONE
#define PLUGIN_NONE
Definition xine_plugin.h:29
PLUGIN_INPUT
#define PLUGIN_INPUT
Definition xine_plugin.h:30

## ◆ ignore_scheme

const char ignore_scheme[][8] = { "cdda:", "file:", "ftp:", "ftpes:", "http:", "https:", "test:", "hls:"}
| static

Referenced by gnomevfs_klass_get_instance().

## ◆ input_info_gnomevfs

const input_info_t input_info_gnomevfs
| static

Initial value:
= {
.priority = 100,
}